> For the complete documentation index, see [llms.txt](https://docs.caf.io/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.caf.io/caf-sdk/caf-sdk-pt-br/android/standalone-modules/document-detector/source-code.md).

# Código-fonte

```kotlin
class MainActivity : AppCompatActivity() {
    private lateinit var binding: ActivityMainBinding

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)

        binding = ActivityMainBinding.inflate(layoutInflater)
        setContentView(binding.root)

        binding.startDocumentDetectorButton.setOnClickListener {
            startDocumentDetector()
        }
    }

    private fun startDocumentDetector(upload: Boolean = false) {
        val documentDetector = buildDocumentDetector(upload)
        val intent = Intent(this, DocumentDetectorActivity::class.java)
        intent.putExtra(DocumentDetector.PARAMETER_NAME, documentDetector)
        startActivityForResult(intent, REQUEST_CODE)
    }

    private fun buildDocumentDetector(upload: Boolean = false): DocumentDetector? =
        DocumentDetector.Builder("eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpc3MiOiI2NTRjZmFlMWM5YTM0NTAwMDg4YzIwODUifQ.maH9fynasnaRR2Hm5PxQ1XzLxlVZiZSvpVDD9zVtfgs")
            .setDocumentCaptureFlow(
                arrayOf(
                    DocumentDetectorStep(Document.CNH_FRONT),
                    DocumentDetectorStep(Document.CNH_BACK),
                )
            )
            .setUploadSettings(
                UploadSettings(upload)
            )
            .setPersonId("12312312312")
            .setUseDeveloperMode(true)
            .setUseAdb(true)
            .setUseDebug(true)
            .build()

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (requestCode == REQUEST_CODE && resultCode == RESULT_OK) {
            val result = data?.getSerializableExtra(
                DocumentDetectorResult.PARAMETER_NAME
            ) as DocumentDetectorResult

            if (!result.wasSuccessful()) {
                result.sdkFailure?.let {
                    onSdkFailure(it)
                }
                return
            }

            println("DocumentDetectorResult: $result")
        } else {
            println("O usuário cancelou a operação")
        }
        super.onActivityResult(requestCode, resultCode, data)
    }

    private fun onSdkFailure(sdkFailure: SDKFailure?) {
        when (sdkFailure) {
            is InvalidTokenReason -> {
                println("SDKFailure: O token inserido como parâmetro não é válido, revise-o por favor")
            }
            is PermissionReason -> {
                println("SDKFailure: O usuário não concedeu as permissões necessárias")
            }
            is AvailabilityReason -> {
                println("SDKFailure: As instruções são enviadas em: ${sdkFailure.message}")
            }
            is NetworkReason -> {
                println("SDKFailure: Houve um problema com a conexão com a internet")
            }
            is ServerReason -> {
                println("SDKFailure: Houve um problema em qualquer comunicação com os servidores da CAF, avise-nos!")
            }
            is SecurityReason -> {
                println("SDKFailure: Houve um problema de segurança no dispositivo do usuário")
            }
            is StorageReason -> {
                println("SDKFailure: Houve um problema com o armazenamento interno do dispositivo do usuário")
            }
            is LibraryReason -> {
                println("SDKFailure: Houve um problema com a biblioteca interna")
            }
            else -> {
                println("SDKFailure: Motivo desconhecido")
            }
        }
    }

    companion object {
        private const val REQUEST_CODE = 123456
    }
}
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.caf.io/caf-sdk/caf-sdk-pt-br/android/standalone-modules/document-detector/source-code.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
